package com.bzd.system.service;

import com.bzd.common.config.dao.DaoBase;
import com.bzd.common.config.dao.DaoSupport;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.utils.DateUtils;
import com.bzd.common.utils.StringUtils;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import static com.bzd.common.utils.ShiroUtils.getSysUser;


/**
 * 药事服务管理 service
 */
@Service
public class PharmaceuticalService {

    @Autowired
    private DaoBase dao;

    @Resource(name = "daoSupport")
    private DaoSupport daoSupport;

    public List<PageData> findArchivesList(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectArchivesList", pd);
//        pd.put("archiveId", pd.get("id"));
//        List<PageData> listBasicInfomation= (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectPatientBasicInfo", pd);
//        list.addAll(listBasicInfomation);
//        return list;

    }
    public List<PageData> findBasicInfomation(PageData pd) throws Exception{
        pd.put("archiveId", pd.get("id"));
        List<PageData> listBasicInfomation= (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectPatientBasicInfo", pd);
        return listBasicInfomation;

    }
    public Integer archivesRemove(PageData pd)throws Exception {
        return daoSupport.delete("PharmaceuticalServiceMapper.archivesRemove", pd);
    }

    @Transactional(rollbackFor = Exception.class)
    public Integer updateArchives(PageData pd)throws Exception {
        pd.put("archiveId", pd.get("id"));
        pd.put("createdBy", getSysUser().getLoginName());
        pd.put("createdAt", DateUtils.getTime());

        Object rowshbsObj = pd.get("rowshbs");
        Object rowsRcordsObj = pd.get("rowsRcords");
        Object rowslxrObj = pd.get("rowslxr");
        // 检查 basicInformation 完善基础信息部分标识=true 是否为 null
        Object basicInformation = pd.get("basicInformation");
        if (basicInformation != null && "true".equals(basicInformation.toString())) {
          Object updatePatientBasicInfo =  daoSupport.findForObject("PharmaceuticalServiceMapper.selectPatientBasicInfoById", pd);
          if(StringUtils.isNull(updatePatientBasicInfo)){
              daoSupport.update("PharmaceuticalServiceMapper.insertPatientBasicInfo", pd);
              if(StringUtils.isNotNull(rowshbsObj)){
                  try {
                      // 将 JSON 字符串转换为 List<Map<String, Object>>
                      ObjectMapper objectMapper = new ObjectMapper();
                      List<Map<String, Object>> rowsList = objectMapper.readValue(rowshbsObj.toString(), List.class);
                      // 遍历列表并调用插入数据接口
                      for (Map<String, Object> hbs : rowsList) {
                      pd.put("disease", hbs.get("disease"));
                      pd.put("member", hbs.get("member"));
                      daoSupport.update("PharmaceuticalServiceMapper.insertFamilyHistory", pd);
                      //daoSupport.update("PharmaceuticalServiceMapper.updateFamilyHistory", pd);
                  }
              } catch (Exception e) {
                  e.printStackTrace();
              }
              }
              if(StringUtils.isNotNull(rowsRcordsObj)){
                  try {
                      // 将 JSON 字符串转换为 List<Map<String, Object>>
                      ObjectMapper objectMapper = new ObjectMapper();
                      List<Map<String, Object>> rowsList = objectMapper.readValue(rowsRcordsObj.toString(), List.class);
                      // 遍历列表并调用插入数据接口
                      for (Map<String, Object> Rcords : rowsList) {
                      pd.put("medicationDescription", Rcords.get("medicationDescription"));
                      pd.put("medicationType", Rcords.get("medicationType"));
                      daoSupport.update("PharmaceuticalServiceMapper.insertMedicationRecord", pd);
                      //daoSupport.update("PharmaceuticalServiceMapper.updateMedicationRecord", pd);
                      }
                  } catch (Exception e) {
                      e.printStackTrace();
                  }
              }
              if(StringUtils.isNotNull(rowslxrObj)){
                  try {
                      // 将 JSON 字符串转换为 List<Map<String, Object>>
                      ObjectMapper objectMapper = new ObjectMapper();
                      List<Map<String, Object>> rowsList = objectMapper.readValue(rowslxrObj.toString(), List.class);
                      // 遍历列表并调用插入数据接口
                      for (Map<String, Object> lxr : rowsList) {
                          pd.put("contactPhone", lxr.get("contactPhone"));
                          pd.put("contactName", lxr.get("contactName"));
                          pd.put("contactRelationship", lxr.get("contactRelationship"));
                          daoSupport.update("PharmaceuticalServiceMapper.insertContact", pd);
                          // daoSupport.update("PharmaceuticalServiceMapper.updateContact", pd);
                      }
                  } catch (Exception e) {
                      e.printStackTrace();
                  }

              }
          }else {
                     //有患者基础信息 做修改
              if(StringUtils.isNotNull(rowshbsObj)){
                  try {
                      daoSupport.update("PharmaceuticalServiceMapper.DeleteFamilyHistory", pd);
                      pd.put("updatedAt", DateUtils.getTime());

                      // 将 JSON 字符串转换为 List<Map<String, Object>>
                      ObjectMapper objectMapper = new ObjectMapper();
                      List<Map<String, Object>> rowsList = objectMapper.readValue(rowshbsObj.toString(), List.class);
                      // 遍历列表并调用插入数据接口
                      for (Map<String, Object> hbs : rowsList) {
                          pd.put("disease", hbs.get("disease"));
                          pd.put("member", hbs.get("member"));
                          daoSupport.update("PharmaceuticalServiceMapper.insertFamilyHistory", pd);
                          //daoSupport.update("PharmaceuticalServiceMapper.updateFamilyHistory", pd);
                      }
                  } catch (Exception e) {
                      e.printStackTrace();
                  }
              }
              if(StringUtils.isNotNull(rowsRcordsObj)){
                  try {
                      daoSupport.update("PharmaceuticalServiceMapper.DeleteMedicationRecord", pd);
                      // 将 JSON 字符串转换为 List<Map<String, Object>>
                      ObjectMapper objectMapper = new ObjectMapper();
                      List<Map<String, Object>> rowsList = objectMapper.readValue(rowsRcordsObj.toString(), List.class);
                      // 遍历列表并调用插入数据接口
                      for (Map<String, Object> Rcords : rowsList) {
                          pd.put("medicationDescription", Rcords.get("medicationDescription"));
                          pd.put("medicationType", Rcords.get("medicationType"));
                          daoSupport.update("PharmaceuticalServiceMapper.insertMedicationRecord", pd);
                          //daoSupport.update("PharmaceuticalServiceMapper.updateMedicationRecord", pd);
                      }
                  } catch (Exception e) {
                      e.printStackTrace();
                  }
              }
              if(StringUtils.isNotNull(rowslxrObj)){
                  try {
                      daoSupport.update("PharmaceuticalServiceMapper.DeleteContact", pd);
                      // 将 JSON 字符串转换为 List<Map<String, Object>>
                      ObjectMapper objectMapper = new ObjectMapper();
                      List<Map<String, Object>> rowsList = objectMapper.readValue(rowslxrObj.toString(), List.class);
                      // 遍历列表并调用插入数据接口
                      for (Map<String, Object> lxr : rowsList) {
                          pd.put("contactPhone", lxr.get("contactPhone"));
                          pd.put("contactName", lxr.get("contactName"));
                          pd.put("contactRelationship", lxr.get("contactRelationship"));
                          daoSupport.update("PharmaceuticalServiceMapper.insertContact", pd);
                          // daoSupport.update("PharmaceuticalServiceMapper.updateContact", pd);
                      }
                  } catch (Exception e) {
                      e.printStackTrace();
                  }

              }
              pd.put("basicInfoCompleter", getSysUser().getLoginName());
              pd.put("recordUpdateTimestamp", DateUtils.getTime());
              daoSupport.update("PharmaceuticalServiceMapper.updatePatientBasicInfo", pd);
          }
        }
        pd.put("archiveCreator", getSysUser().getLoginName());//档案更新人
        pd.put("updateTime", DateUtils.getTime());//更新时间
        return daoSupport.update("PharmaceuticalServiceMapper.updateArchives", pd);
    }

    public List<PageData> findrecordsByarchiveId(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.findrecordsByarchiveId", pd);

    }
    public List<PageData> findhistoryByarchiveId(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.findhistoryByarchiveId", pd);

    }
    public List<PageData> findcontactsByarchiveId(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.findcontactsByarchiveId", pd);

    }
    public List<PageData> findFollowUpList(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectFollowUpList", pd);

    }
    public Object findBasicInfoById(PageData pd) throws Exception{
        return  daoSupport.findForObject("PharmaceuticalServiceMapper.selectPatientBasicInfoById", pd);

    }
    public Integer followUpRemove(PageData pd)throws Exception {
        return daoSupport.delete("PharmaceuticalServiceMapper.followUpRemove", pd);
    }


    public Integer updateFollowUp(PageData pd)throws Exception {
        return daoSupport.update("PharmaceuticalServiceMapper.updateFollowUp", pd);
    }

    public List<PageData> findFollowUpAssignList(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectFollowUpAssignList", pd);

    }

    public Integer followUpAssignRemove(PageData pd)throws Exception {
        return daoSupport.delete("PharmaceuticalServiceMapper.followUpAssignRemove", pd);
    }


    public Integer updateFollowUpAssign(PageData pd)throws Exception {
        return daoSupport.update("PharmaceuticalServiceMapper.updateFollowUpAssign", pd);
    }

    public List<PageData> findPatientCounselingList(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectPatientCounselingList", pd);

    }

    public Integer patientCounselingRemove(PageData pd)throws Exception {
        return daoSupport.delete("PharmaceuticalServiceMapper.patientCounselingRemove", pd);
    }


    public Integer updatePatientCounseling(PageData pd)throws Exception {
        return daoSupport.update("PharmaceuticalServiceMapper.updatePatientCounseling", pd);
    }

    public List<PageData> findFollowUpEvaluationList(PageData pd) throws Exception{
        return (List<PageData>) daoSupport.findForList("PharmaceuticalServiceMapper.selectFindFollowUpEvaluationList", pd);

    }

    public Integer followUpEvaluationRemove(PageData pd)throws Exception {
        return daoSupport.delete("PharmaceuticalServiceMapper.findFollowUpEvaluationRemove", pd);
    }


    @Transactional(rollbackFor = Exception.class)
    public Integer updateFollowUpEvaluation(PageData pd)throws Exception {
        return daoSupport.update("PharmaceuticalServiceMapper.updateFindFollowUpEvaluation", pd);
    }

    public boolean checkPatientIsExist(PageData pd) throws Exception{
        Object PageData =daoSupport.findForObject("PharmaceuticalServiceMapper.checkPatientIsExist", pd);
        return StringUtils.isNull(PageData);

    }
    /**
     * 新建患者档案
     */
    public Integer addArchives(PageData pd)throws Exception {
        pd.put("creator", getSysUser().getLoginName());//创建人
        pd.put("createTime", DateUtils.getTime());//创建时间
        pd.put("archiveCreator", getSysUser().getLoginName());//档案创建人
        pd.put("archiveCompleteStatus", 0);//档案是否完善 1已完善 0未完善
        pd.put("realNameStatus", 0);//是否实名 1已经实名 0未实名 待对接服务校验
        return daoSupport.update("PharmaceuticalServiceMapper.insertArchiveRecord", pd);
    }
}
